/*********************************************************
 Copyright (C) 1994 Patrick Voigt
*********************************************************/

#include <sys/stat.h>

#define IS_DIR 1
#define IS_REG 2
#define IS_CHR 3
#define IS_BLK 4
#define IS_FIFO 5
#define IS_SOCK 6
#define IS_LNKD 7
#define IS_LNKR 8
#define IS_LNKO 9
#define IS_LNKN 10

class mdir
{
  public:

    mdir ();
   ~mdir ();

       void change_sort (int);            // change case of sorting the directory entries
       void readmdir (char*);             // reads the contents of directory
       char *get_path () {return path;}   // returns the actual path 
  struct stat *get_stat (int);            // gets infos of a file
                                          // returns 1 if it fails
        int get_anz () {return anz;}      // returns number of directory emtries

        int find_file (char *name);
       char *get_name (int);              // returns the filename
      off_t get_st_size (int);
     time_t get_st_mtime (int);
       int  get_st_mode (int);
        int get_st_type (int);

 protected:

        int compare (int, int);
       void sort (int, int);

    int *array;                           // array of indizies in struct info

    struct info
    {
       char *name;                        // name of the file
       off_t size;
      time_t time;
	 int type;
         int mode;
    } *array_info;

    struct stat x;                        // pointer to struct of fileinfos
    char *path;                           // contains the actual path
    int anz;                              // number of directory entries 
    int sort_case;                        // directory entries sorting algorithm
};
